#include <windows.h>
#include <time.h>
#include <stdio.h>
#include <conio.h>
#include "USB_clss.h"
#include "LL_USB_c.h"

//Last modified: 9-23-03

MyLL_USB MyLL_USB;
BOOLEAN DisplayWarning();

main()
{
	if(!DisplayWarning()) return 0;

	system("cls"); printf(MID"Initializing - please wait. . . . . .\r\n");
	if(!MyLL_USB.Init_SP()) { printf("FAILED TO INITIALIZE .. exiting\r\n"); return 0; }
	MyLL_USB.GetDefDev_SP(&usDevID); MyLL_USB.GetCurChan(&bDevChan);

	while(fDoLoop)
	{
		CLS printf(MID 
			"Using Device ID #%u\n"
			"Enter a keystroke:\n\n"
			"P)olled data mode\t- get random voltages\n"
			"S)ingle chan scan mode\t- scan at preset interval for single channel\n"
			"\nany other key to exit", usDevID); 
		while(!kbhit()); int iKey = getch() | 0x20;

		switch((BYTE)iKey)
		{
			case 'p':  GetVoltageByPolling(); break;
			case 's':  DoScanSingleChan(); break;
			default: fDoLoop = FALSE; break;
		}
	}
	system("cls"); printf(MID"closing application - please wait...");
	return 0;
}


//----------------------------------------------\
// #### get voltages in a polled mode state >>>>>>
//----------------------------------------------/
BOOLEAN GetVoltageByPolling()
{
	clkWaitPeriod = clock() + 500;
	while(!kbhit())
	{
		if(clock() > clkWaitPeriod)
		{
			if(!MyLL_USB.GetOneVoltage_SP(&dblVoltage)) { printf("FAILED TO GET VOLTAGE .. exiting\r\n"); return 0; } 
			system("cls"); printf(MID"POLLED DATA MODE\n\nany key to exit\n\nDev: %u  Chan: %d\nvoltage:", usDevID, bDevChan);
			printf(" % 2.6lf", dblVoltage); 
			clkWaitPeriod = clock() + 500;
		}
	}
	getch();
	return TRUE;
}


//----------------------------------------------\
// #### do a single-channel scan  >>>>>>>>>>>>>>>>
//----------------------------------------------/
BOOLEAN DoScanSingleChan()
{
	PSCAN_INFO_USB_PNTS_SINGLE pScanInfo = new SCAN_INFO_USB_PNTS_SINGLE[1];
	pScanInfo->usNumPntsToRead = BUFF_SIZE; 
	USHORT usIndex = 0;

	system("cls"); printf(MID"starting scan - please wait. . . . .");

	if(!MyLL_USB.StartScan_SP())
	{
		system("cls"); printf(MID"failed to start scan. (any key to continue:");
		while(!kbhit()); getch();
		return FALSE;
	}
	system("cls"); printf(MID"getting scan data. . . .");
	DOUBLE dblCurAvgVoltage;
	uiPntCnt = 0;
	pScanInfo->uiStatusFlags = 0;
	while(!kbhit())
	{
		if(MyLL_USB.GetScanVoltage_SP(pScanInfo, adblScanVoltages))
		{
			uiPntCnt = uiPntCnt + BUFF_SIZE;
			dblCurAvgVoltage = 0;
			for(usIndex = 0; usIndex < BUFF_SIZE; usIndex++) dblCurAvgVoltage = dblCurAvgVoltage + adblScanVoltages[usIndex];
			dblCurAvgVoltage = dblCurAvgVoltage / (double)BUFF_SIZE;
			system("cls"); printf(MID"SINGLE-CHAN SCAN MODE\nDevice: %u   Chan: %d\n\nany key to exit\n\nscan#\t\t voltage\n", usDevID, bDevChan);
			printf("% 6u:\t\t% 2.5lf", uiPntCnt, dblCurAvgVoltage); 
		}
		if((UINT)pScanInfo->uiStatusFlags & SCAN_HALTED)
		{
			break;
		}
	}
	if((UINT)pScanInfo->uiStatusFlags & SCAN_HALTED){ system("cls"); printf(MID"SCAN HALTED - exiting scan function"); }
	else{ system("cls"); printf(MID"exiting scan function - please wait . . . . ."); }
	MyLL_USB.EndScan_SP();
	delete [] pScanInfo;
	getch();
	return TRUE;
}


BOOLEAN DisplayWarning()
{
	while(TRUE)
	{
		system("cls");
		printf("\n\n\n\n\n");
		printf( "If there are more than one of our USB devices currently connected\n"
				"   which are being used by other applications, this application's\n"
				"   initialization process could take a long time depending on the\n"
				"   number of devices connected and being used by other applications.\n\n"
				"With that in mind do you want to continue?\n\n"
				"(Y)es  (N)o: ");

		while(!kbhit()); int iKey = getch() | 0x20;
		switch((BYTE)iKey) { case 'y':  return TRUE; case 'n':  return FALSE; }
	}
}

